routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});


// Route::get('/test','WelcomeController@abc');

// Route::post('add-data','WelcomeController@add')->name('add-data');

// Route::get('viewdata','WelcomeController@data')->name('viewdata');


//  Route::resource('post','PostController');

 Route::resource('demo','DemoController');


//Route::post('addpost','PostController@store');

//  Route::resource('post', 'PostController');

app/Models/Abc.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Abc extends Model
{
    use HasFactory;
}

app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    use HasFactory;

 
    
}

app/Models/Test.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Test extends Model
{
    use HasFactory;

}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/DemoController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Abc;

class DemoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
       $data = Abc::all();
       return view('demo.view',compact('data'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
       return view('demo.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
       $bc = new Abc;
       $data = $request->all();
       $bc->firstname = $data['firstname'];
       $bc->lastname = $data['lastname'];
       $bc->save();
       
       return redirect()->route('demo.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       $data = Abc::findorfail($id);
       return view('demo.edit',compact('data'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
       $bc = Abc::findorfail($id);
       $data = $request->all();
       $bc->firstname = $data['firstname'];
       $bc->lastname = $data['lastname'];
       $bc->save();

       return redirect()->route('demo.index');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $data = Abc::findorfail($id);
        $data->delete();

        return redirect()->back();
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Post;

class PostController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
      $abc = Post::all();
      return view('post.index',compact('abc'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
      return view('post.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $post = new Post(); //Object Create (Model Define)
        $data = $request->all(); //storing all values in data variable
        $rules = [      //rules define 
            'title' => 'required',
            'description' => 'required' 
        ];
        $message = [     //validation message
            'title.required' => 'Please Enter Title',
            'description.required' => 'Please Enter description'
        ];

        $this->validate($request,$rules,$message);  
        $post->title = $data['title'];
        $post->description = $data['description'];
        $post->save();
        return redirect()->back()->with('success','You Have Successfully Inserted'); 

        
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       $a = Post::findorfail($id);  //Select * from post where id = '1'
       return view('post.edit',compact('a'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $ab = Post::findorfail($id);
        $data = $request->all();
        $ab->title = $data['title'];
        $ab->description = $data['description'];
        $ab->save();

        return redirect()->route('post.index');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
       $abc = Post::findorfail($id);
       $abc->delete();
       return redirect()->route('post.index'); //
    }
}

app/Http/Controllers/WelcomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Test;   //model path 

class WelcomeController extends Controller
{
    public function abc(){

        return view('test');
    }

    public function data(){
        $abc = Test::all();
        return view('viewdata',compact('abc'));
    }

    public function add(Request $request){
       $data  = $request->all(); 
       $abc = new Test; 
        $abc->title = $data['title'];
        $abc->details = $data['details'];
        $abc->save();
        return view('test')->with('success','You have succesfully added');

    }


}

resources/views/demo/create.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <form action="{{route('demo.store')}}" method="post">
        @csrf    
    <p>First Name : <input type="text" name="firstname" id=""></p>
    <p>Last Name: <input type="text" name="lastname" id=""></p>
    <button type="submit">Add</button>
    </form>
</body>
</html>

resources/views/demo/edit.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <form action="{{route('demo.update',$data->id)}}" method="post">
        @csrf
        @method("Patch")    
    <p>First Name : <input type="text" name="firstname" id="" value="{{$data->firstname}}"></p>
    <p>Last Name: <input type="text" name="lastname" id="" value = "{{$data->lastname}}"></p>
    <button type="submit">Update</button>
    </form>
</body>
</html>

resources/views/demo/view.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>

<a href="{{route('demo.create')}}">Add New</a>
    <table>
        <tr>
            <td>First Name</td>
            <td>Last Name</td>
            <td>Action</td>
        </tr>

        @foreach($data as $abc)
        <tr>
            <td>{{$abc->firstname}}</td>
            <td>{{$abc->lastname}}</td>
            <td><a href="{{route('demo.edit',$abc->id)}}">Edit</a> || 
                <form action="{{route('demo.destroy',$abc->id)}}" method="post" onsubmit="return confirm('Are you Sure')">
                @method('delete')
                @csrf   
                <button type="submit">  Delete </button>
                </form>
        </td>
        </tr>
        @endforeach

    </table>
</body>
</html>

resources/views/post/create.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Post Add</title>
</head>
<body>

@if(Session::has('success'))
   {{Session::get('success')}}
@endif
@if($errors->any())
                            <div class="alert alert-danger">
                                <ul style="list-style:none;">
                                  @foreach($errors->all() as $error)
                                    <li>{{$error}}</li>
                                  @endforeach
                                </ul>
                            </div>
                        @endif
    <h1>Add New Post</h1>
    <form action="{{route('post.store')}}" method="post">
        @csrf
        <p>Title : <input type="text" name="title" ></p>
        <p>Description : <textarea name="description"></textarea></p>
        <button type="submit">Submit</button>
    </form>
</body>
</html>

resources/views/post/edit.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Post Add</title>
</head>
<body>

    <h1>Edit Post</h1>
    <form action="{{route('post.update',$a->id)}}" method="post"> 
        <!-- compact a -->
        @csrf
        @method('Patch')
        <p>Title : <input type="text" name="title" value="{{$a->title}}" ></p>
        <p>Description : <textarea name="description" >{{$a->description}}</textarea></p>
        <p><button type="submit">Submit</button></p>
    </form>
</body>
</html>

resources/views/post/index.blade.php
<html>
    <head><title>Post</title></head>
    <body>
        <h1>Post</h1>
        <a href="{{route('post.create')}}">Add New Post</a>

    <h2>View data</h2>

    <table>
        <tr>
            <td>Title</td>
            <td>Details</td>
             <td>Action</td>
        </tr>
        @foreach($abc as $test)
        <tr>
            <td>{{$test->title}}</td>
            <td>{{$test->description}}</td>
            <td><a href="{{route('post.edit',$test->id)}}">Edit</a>
           
        </tr>
        @endforeach
    </table>
</body>
</html>
  

resources/views/test.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Test</title>
</head>
<body>
    <h2>Test Form</h2>

    <form action="{{route('add-data')}}" method="post">
        @csrf
        <p> Title : <input type="text" name="title" > </p>
        <p> Details : <input type="text" name="details" ></p>

        <p><button type="submit">Add</button></p>
    </form>


</body>
</html>

resources/views/viewdata.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>View Data</title>
</head>
<body>
    <h2>View data</h2>

    <table>
        <tr>
            <td>Title</td>
            <td>Details</td>
             <td>Action</td>
        </tr>
        @foreach($abc as $test)
        <tr>
            <td>{{$test->title}}</td>
            <td>{{$test->details}}</td>
            <td><a href="{{route('post.edit',$test->id)}}">Edit</a></td>
        </tr>
        @endforeach
    </table>
</body>
</html>